# AnyKernel2 Ramdisk Mod Script
# osm0sis @ xda-developers

## AnyKernel setup
# begin properties
properties() {
kernel.string=PRIME-Kernel
do.devicecheck=1
do.modules=0
do.cleanup=1
do.cleanuponabort=0
device.name1=N910
device.name2=N915
device.name3=N916
device.name4=
device.name5=
} # end properties

file_getprop() { grep "^$2" "$1" | cut -d= -f2; }

# shell variables
block=$(ls /dev/block/platform/*/by-name/BOOT)
is_slot_device=0
is_any_port_rom=0
is_s8p_port_rom=0
is_touchwiz=0
need_gpu_patch=0

test -f /system/framework/ssrm.jar && is_any_port_rom=1
test -f /system/framework/SmpsManager.jar && is_s8p_port_rom=1
test -f /system/framework/sec_edm.jar && is_touchwiz=1

is_pure_edition=$(cat kernel.string|grep -c "Pure")

## AnyKernel methods (DO NOT CHANGE)
# import patching functions/variables - see for reference
. /tmp/anykernel/tools/ak2-core.sh


## AnyKernel permissions
# set permissions for included ramdisk files
chmod -R 755 $ramdisk
find $ramdisk -type d -exec chmod 755 {} \;
find $ramdisk -name '?*.sh' -type f -exec chmod 0755 {} \;
find $ramdisk -name '?*.py' -type f -exec chmod 0755 {} \;
chmod 644 $ramdisk/file_contexts
chmod 644 $ramdisk/se*
chmod 750 $ramdisk/init
chmod 644 $ramdisk/*.rc
chmod 640 $ramdisk/fstab*
chmod 644 $ramdisk/default.prop
chmod 771 $ramdisk/data
chmod 750 $ramdisk/sbin
chmod 750 $ramdisk/sbin/*
chmod 755 $ramdisk/res/*
chmod 755 $ramdisk/res/bin/*

## AnyKernel install
ui_print "    dump boot-image..."
dump_boot

# begin ramdisk changes
# clear ------------------------------------------------------------------------
ui_print "    useless files removal"
remove_list="init.spectrum.rc init.services.rc init.PRIME-Kernel.rc init.spectrum.rc"
for i in $remove_list; do
	rm $i
	sed "/$i/d" init.rc 
	sed "/$i/d" init.universal5433.rc 
done
find ramdisk/res ! \( \( -type d -path 'ramdisk/res/images' -o -path 'ramdisk/res/apk/com.af.synapse-1' -o -path 'ramdisk/res/synapse' -o -path 'ramdisk/res/bin' -o -path 'ramdisk/res/stuff' \) -prune \) -type f -exec rm -f {} \;

# Disabled duble init.d
#if test -f /system/etc/init.sec.boot.sh; then
#	mv /system/etc/init.sec.boot.sh /system/etc/init.sec.boot.sh.bak
#fi

# busybox install
cp $bin/busybox $ramdisk/res/bin/


# default.prop -----------------------------------------------------------------
ui_print "    patching ramdisk"
#patch_prop default.prop persist.sys.usb.config "mtp,adb"
#patch_prop default.prop "ro.secure" "0"
#patch_prop default.prop "ro.debuggable" "1"
#insert_line default.prop "persist.service.adb.enable=" after "persist.sys.usb.config=" "persist.service.adb.enable=1"
if [ $is_touchwiz -eq 1 ]; then
	insert_line default.prop "# PRIME-KERNEL_PROPERTIES" after "debug.atrace.tags.enableflags=0" "\n#\n# PRIME-KERNEL_PROPERTIES\n#\nsys.prime-kernel.installed=1\n\n#"
#	insert_line default.prop "telephony.lteOnCdmaDevice=0" before "persist.security.ams.enforcing=" "telephony.lteOnCdmaDevice=0"
	insert_line default.prop "ro.securestorage.support=" after "sys.prime-kernel.installed=1" "ro.securestorage.support=false"
#	insert_line default.prop "ro.securestorage.knox=false" after "ro.securestorage.support=" "ro.securestorage.knox=false"
	insert_line default.prop "ro.config.tima=" after "ro.securestorage.support=" "ro.config.tima=0"
	insert_line default.prop "ro.config.rkp=" after "ro.config.tima=" "ro.config.rkp=false"
	insert_line default.prop "ro.config.kap=" after "ro.config.rkp=" "ro.config.kap=false"
	insert_line default.prop "wlan.wfd.hdcp=" after "ro.config.kap=" "wlan.wfd.hdcp=disable"
	insert_line default.prop "ro.config.dmverity=" after "wlan.wfd.hdcp=" "ro.config.dmverity=false"

#	patch_prop default.prop telephony.lteOnCdmaDevice 0
	patch_prop default.prop ro.securestorage.support false
	patch_prop default.prop ro.config.tima 0
	patch_prop default.prop ro.config.rkp false
	patch_prop default.prop ro.config.kap false
	patch_prop default.prop wlan.wfd.hdcp disable
	patch_prop default.prop ro.config.dmverity false
#	patch_prop default.prop persist.security.ams.enforcing 1
#	patch_prop default.prop persist.sys.usb.config "mtp,adb"
fi


# init.rc
sed -i "/init.prime-kernel.rc/d" init.rc
sed -i "/init.prime-kernel.rc/d" init.universal5433.rc
if [ $is_pure_edition -eq 0 ]; then
	#line=$((`grep -n "import" "init.rc" | tail -n1 | cut -d: -f1` + 1));
	#sed -i "${line}s;^;import /init.prime-kernel.rc\n;" init.rc
	insert_line init.universal5433.rc "import /init.prime-kernel.rc" before "import" "import /init.prime-kernel.rc"
fi

sed -i "s/.*start auditd/#start auditd/g" init.rc
for i in $(grep -n "#start auditd" init.rc|cut -d: -f1); do
	ret=$(grep -n -m1 "#start auditd" init.rc)
	line=$(($(echo "$ret"|cut -d: -f1) - 1))
	ret=$(cat init.rc|head -n$line|tail -n1)
	if echo $ret | grep -q "on property:"; then
		sed -i "$line,$((line + 1))d" init.rc
	fi
done

#remove_section init.rc "on property:sys.boot_completed=1" "#start auditd"
remove_section init.rc "on property:selinux.reload_policy=1" "chown system system /sys/fs/selinux/commit_pending_bools"
remove_section init.rc "# Reload SE Android Policy for MDM" "setprop selinux.reload_policy 1"
remove_section init.rc "## WTL_EDM_START" "## WTL_EDM_END"
remove_section init.rc "service auditd /system/bin/auditd -k" ".*oneshot"
replace_line init.rc "setprop selinux.reload_policy 1" "    #setprop selinux.reload_policy 1"
replace_line init.rc "setprop selinux.reload_policy 1" "    #setprop selinux.reload_policy 1"
replace_line init.rc "setprop selinux.reload_policy 1" "    #setprop selinux.reload_policy 1"


# init.samsungexynos8890.rc ----------------------------------------------------
if [ $is_touchwiz -eq 1 ]; then
	insert_line init.universal5433.rc "mount f2fs /dev/block/mmcblk0p18 /system wait ro" after "mount ext4 /dev/block/mmcblk0p18 /system wait ro" "    mount f2fs /dev/block/mmcblk0p18 /system wait ro"
fi



# replace

if [ $is_pure_edition -eq 1 ]; then
  ui_print "    is pure edition"
  replace_file fstab.universal5433 644 TouchWiz/fstab.pure
  #rm -Rf $ramdisk/res/bin
  rm -Rf $ramdisk/res/synapse
  rm -Rf $ramdisk/res/stuff
  rm -Rf $ramdisk/res/apk
  rm -Rf $ramdisk/res/sbin/uci
  #rm -Rf $ramdisk/res/sbin/resetprop
else
	replace_file fstab.universal5433 644 TouchWiz/fstab.universal5433
fi
replace_file init.environ.rc 644 TouchWiz/init.environ.rc

# for Magisk
if [ -d .backup ]; then
	cp -f init.rc .backup/
	cp -f fstab.universal5433 .backup/
	sed -i "/init.magisk.rc/d" .backup/init.rc
fi


# end ramdisk changes

ui_print "    write boot-image..."
write_boot

## end install
