#!/system/bin/sh

alias bb=/res/bin/busybox
PRIME=/data/PRIME-Kernel
HIDE_XPOSED=$(cat $PRIME/synapse/settings/hide_xposed_installer)
BAKDIR=$PRIME/xposed-backup
XPOSED_BACKUPS=`ls $BAKDIR|grep ".data.tar.gz"`

if [ "$HIDE_XPOSED" -eq 1 ]; then
	XPOSED_APK=$(cat $PRIME/list/list_xposed_apks.txt)
fi

if [ ! -z "$XPOSED_BACKUPS" ]; then

	for apps in $XPOSED_APK
	do
		[ -z "$apps" ] && continue
		BACKUP_DATA=$BAKDIR/$apps.data.tar.gz
		if [ -e $BACKUP_DATA ]; then
			mkdir -m 0755 -p /data/data/$apps
			bb tar -xzf $BACKUP_DATA -C /data/data/$apps
		fi
	done
fi

